/* Sistemas Integrados TEKNISA
   Gesto de Operador Logistico

Nome: 9114_OPLTRGO.sql

Descrio:
Criada para ativar as etiquetas quando o item do pedido for excludo
e a este item estiver etiquetas relacionadas. 
Criao:
11/05/2015 Joao Paulo Corte
*/

CREATE OR REPLACE TRIGGER ATIVA_ETIQUETA_ITEMPEDEXOL
BEFORE DELETE ON ITEMPEDEXOL FOR EACH ROW
DECLARE
  V_CDFILDEST      ITEMPEDEXOL.CDFILDEST%TYPE;
  V_CDFILLANC      ITEMPEDEXOL.CDFILLANC%TYPE;
  V_NRPEDEXOL      ITEMPEDEXOL.NRPEDEXOL%TYPE;
  V_CDMARCA        ITEMPEDEXOL.CDMARCA%TYPE;
  V_CDPRODUTO      ITEMPEDEXOL.CDPRODUTO%TYPE;
BEGIN
  IF DELETING THEN
    V_CDFILDEST := :OLD.CDFILDEST;  
    V_CDFILLANC := :OLD.CDFILLANC;
    V_NRPEDEXOL := :OLD.NRPEDEXOL;
    V_CDMARCA   := :OLD.CDMARCA;
    V_CDPRODUTO := :OLD.CDPRODUTO;
    FOR C_ETIQUETA IN
        ( SELECT E.CDFILIAL, E.NRLANCTONF, E.NRSEQITPROD, E.NRSEQETIQ, E.CDCODBARRAETIQ, E.DTPROGENPEOL
            FROM RELACPRODOL R, ETIQUETAPRODOL E 
           WHERE R.CDPRARVORIG  = V_CDPRODUTO
             AND R.CDMARCA      = V_CDMARCA
             AND R.CDPRODARVOL  = E.CDPRODUTO
             AND E.CDFILDEST    = V_CDFILDEST
             AND E.CDFILLANC    = V_CDFILLANC
             AND E.NRPEDEXOL    = V_NRPEDEXOL
        )
    LOOP
      IF (C_ETIQUETA.CDCODBARRAETIQ IS NOT NULL) THEN    
        UPDATE ETIQUETAPRODOL
           SET IDSTATUSETIQ = 'A',
               CDFILDEST    = '',
               CDFILLANC    = '',
               NRPEDEXOL    = '',
               DTPROGENPEOL = ''
         WHERE CDFILIAL       = C_ETIQUETA.CDFILIAL
           AND NRLANCTONF     = C_ETIQUETA.NRLANCTONF
           AND NRSEQITPROD    = C_ETIQUETA.NRSEQITPROD
           AND NRSEQETIQ      = C_ETIQUETA.NRSEQETIQ
           AND CDCODBARRAETIQ = C_ETIQUETA.CDCODBARRAETIQ
           AND DTPROGENPEOL   = C_ETIQUETA.DTPROGENPEOL;
      END IF;     
    END LOOP;
  END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATIVA_ETIQUETA_ITEMPEDEXOL','5.85.xxx'); END;
/