var ger01901_cadastrotipoarvoreproduto_controller = function(ScreenService, General) {

	var G_NRARVPRODPAI;
	var G_NMARVPRODPAI;
	var G_NRTPARVPRODPAI;


	this.desabilitaEHabilitaEstrutura = function(widget) {
		widget.container.getWidget("estrutura").getParent().activate();
		widget.container.getWidget("estrutura").isVisible = true;
	};

	this.filtroParaNivelPai = function(widget) {
		var field = widget.getField('NMARVOREPRODPAI');
		if (typeof widget.currentRow.NRARVOREPROD !== "undefined") {
			field.dataSourceFilter.push({
				"name": "NRARVOREPROD",
				"operator": "<>",
				"value": widget.currentRow.NRARVOREPROD
			});
		}
		field.reload();
	};

	this.getArvProdPai = function(widget) {
		G_NRARVPRODPAI = widget.currentRow.NRARVOREPROD;
		G_NMARVPRODPAI = widget.currentRow.NMARVOREPROD;
	};

	this.novoItemEstrutura = function(widget) {
		var novoNrarvoreprodpai;
		var novoNmarvoreprodpai;
		if (widget.mode === "view") {
			novoNrarvoreprodpai = typeof(widget.currentRow.NRARVOREPROD) !== "undefined" ? widget.currentRow.NRARVOREPROD : null;
			novoNmarvoreprodpai = typeof(widget.currentRow.NMARVOREPROD) !== "undefined" ? widget.currentRow.NMARVOREPROD : null;
		}
		else {
			novoNrarvoreprodpai = null;
			novoNmarvoreprodpai = null;
		}

		widget.edit();
		widget.newRow();
		widget.getField('NMARVOREPRODPAI').setValue(novoNmarvoreprodpai);
		widget.currentRow.NRARVOREPRODPAI = novoNrarvoreprodpai;
		widget.currentRow.NRTPARVPRODPAI = widget.currentRow.NRTPARVPROD;

	};

	this.novoTipoArvore = function(widget) {
		widget.newRow();
	};

	this.onEnterEstrutura = function(widget) {
		if (widget.mode == "list") {
			widget.reload();
		}
	};

	this.onEnterTabEstrutura = function(widget) {
		var nrtparvprod = widget.container.getWidget('tipoarvoreproduto').currentRow.NRTPARVPROD;

		var filter = [
			{
				"name": "NRTPARVPROD",
				"operator": "=",
				"value": nrtparvprod
			}
		];

		widget.dataSourceFilter = filter;
	};

	this.onEnterTabTipoArvore = function(widget) {
		if (widget.mode == "edit") {
			widget.container.getWidget("estrutura").enabled = false;
		}
		else {
			widget.container.getWidget("estrutura").enabled = true;
		}
	};

	this.salvarNovoItemEstrutura = function(widget) {
		widget.reload().then(_ => {
			let currentRow = widget.currentRow;
			const widgetTipoArvProd = widget.container.getWidget('tipoarvoreproduto');
			const RowGroupName = widget.currentRow.NMARVOREPROD;

			currentRow.NRTPARVPROD = widgetTipoArvProd.currentRow.NRTPARVPROD;
			currentRow.NRTPARVPRODPAI = widgetTipoArvProd.currentRow.NRTPARVPROD;
			currentRow.NRARVOREPRODPAI = !(typeof currentRow.NRARVOREPRODPAI === "undefined" || currentRow.NRARVOREPRODPAI === null) ? currentRow.NRARVOREPRODPAI : null;

			if (!currentRow.__is_new && verificaParentesco(widget)) {
				if (this.checkGroupingAndTypeTree(widget, RowGroupName) == false) {
					General.saveCrud(widget).then(function() {
						widget.list();
						widget.reload().then(function() {
							widget.view();
							widget.redraw();
						});
					});
				}
			}
			else if (currentRow.__is_new) {
				if (this.checkGroupingAndTypeTree(widget, RowGroupName) == false) {
					General.saveCrud(widget).then(function() {
						currentRow = {};
						widget.reload();
					});
				}
			}
			else {
				ScreenService.showMessage("O grupo nao pode ser movido para um de seus grupos filhos");
			}
		});

	};

	this.salvarTipoArvore = function(widget) {
		const nomeTipoArvore = widget.currentRow.DSTPARVPROD;
		const widgetAgrupArvProd = widget.container.getWidget("estrutura");

		if (!widget.isValid()) return;

		widget.reload().then(_ => {

			if (this.checkGroupingAndTypeTree(widget, nomeTipoArvore) == false) {
				General.saveCrud(widget).then(() => {
					if (!widget.currentRow.__is_new) {
						widget.list();
						widgetAgrupArvProd.enabled = true;
						widget.reload().then(_ => {
							widget.view();
							widget.redraw();
						});
					}
					else {
						widget.currentRow = {};
						widget.reload();
					}
					widgetAgrupArvProd.enabled = true;
				});
			}
		});
	};

	this.checkGroupingAndTypeTree = (widget, currentRowName) => {
		const data = widget.dataSource.data;
		const dataMin = data.length - 1;
		const currentRow = widget.currentRow;

		if (data.length == 0) return false;
		for (let index in data) {
			if (widget.name === 'tipoarvoreproduto') {
				if (data[index].DSTPARVPROD == currentRowName) {
					ScreenService.showMessage("Impossível adicionar. Tipo de Árvore já existente.");
					widget.reload();
					break;
				}
			}
			else {
				if (currentRow.NRARVOREPRODPAI == null || currentRow.NRARVOREPRODPAI == "") {
					if (data[index].NMARVOREPROD == currentRowName) {
						if ((currentRow.__is_new == true && currentRow._level == 1) || (currentRow.__is_new == false && currentRow._level != 1)) {
							ScreenService.showMessage("Impossível adicionar. Agrupamento de Árvore já existente.");
							widget.reload();
							break;
						}
					}
				}
			}
			if (index == dataMin)
				return false;
		}
	};

	var verificaParentesco = function(widget) {

		var valido = true;

		if (!widget.currentRow.__is_new) {
			var rows = widget.dataSource.data;
			var nrarvoreprodpai = widget.currentRow.NRARVOREPRODPAI !== "undefined" && widget.currentRow.NRARVOREPRODPAI !== null ? widget.currentRow.NRARVOREPRODPAI.toString() : "";
			var nrarvoreprod = widget.currentRow.NRARVOREPROD.toString();
			rows.forEach(function(row) {
				if (row.NRARVOREPROD === nrarvoreprodpai) {
					if (row.NRARVOREPRODPAI === nrarvoreprod)
						valido = false;
				}
			});
		}

		return valido;

	};
};
Configuration(function(ContextRegister, eventEngine) {
	ContextRegister.register('ger01901_cadastrotipoarvoreproduto_controller', ger01901_cadastrotipoarvoreproduto_controller);
});
